// Persistence of Vision RayTracer version 2.2 Scene description file
// File: KIDSTUF1.POV
// Description: A Lego model I used to play with when I was a kid...
// Date: 03/21/94
// Author: Anton Raves
//

#include "lego.inc"
#include "base_1.inc"
#include "world1.inc"

camera {
  location  <-62.5, 75, -250>
  direction 2*z
  up        y
  right     4/3*x
  look_at   <0, 30, 0>
}

object { light_source { <60, 200, -150> color red 1 green 1 blue 1 } }
object { light_source { <60, 200, 150> color red 1 green 1 blue 1 } }

#declare Rotor =
object {
  union {
    object { Rotor_piece texture { Grey_tex } }
    object { FFBlock1_8 translate <8, 10, 0> texture { Grey_tex } }
    object { FFBlock1_8 translate <-64, 10, 0> texture { Grey_tex } }
  }
  bounded_by { box { <-69, -1, -21> <69, 14, 21> } }
}

#declare Heli =
object {
  union {
    object { F_Block1_6 texture { Black_tex } }
    object { F_Block1_6 translate <0, 0, 40> texture { Black_tex } }
    object { Bar1_6 rotate 90*y translate <8, 3, 40> texture { Yellow_tex } }
    object { Bar1_6 rotate 90*y translate <24, 3, 40> texture { Yellow_tex } }
    object { F_Block1_3 translate <8, 12, 8> texture { Red_tex } }
    object { F_Block1_3 translate <8, 12, 32> texture { Red_tex } }
    object { F_Block2_4 translate <0, 12, 16> texture { Red_tex } }

// If you want to use the stick at another angle, then first rotate the following object around its
// z-axis and then move it to its position on the joy base ! ( Which is <x, y+5, z> )
    object { Joy_stick rotate -30*z translate <0, 20, 16> texture { Black_tex } }
    object { Joy_base translate <0, 15, 16> texture { Yellow_tex } }
    object { Joy_stick rotate -30*z translate <0, 20, 24> texture { Black_tex } }
    object { Joy_base translate <0, 15, 24> texture { Yellow_tex } }
    object { I_Slope2_2 translate <24, 15, 16> texture { Black_tex } }
    object { Slope1_3 translate <8, 15, 32> texture { Black_tex } }
    object { Slope1_3 translate <8, 15, 8> texture { Black_tex } }
    object { H_Block1_4 rotate -90*y translate <24, 24, 8> texture { Black_tex } }
    object { I_Slope2_3 translate <32, 24, 16> texture { Black_tex } }
    object { FSBlock1_2 rotate -90*y translate <40, 33, 16> texture { Yellow_tex } }
    object { FSBlock1_2 rotate -90*y translate <48, 33, 16> texture { Yellow_tex } }
    object { F_Block1_4 rotate -90*y translate <24, 36, 8> texture { Red_tex } }
    object { F_Block1_8 translate <56, 33, 20> texture { Yellow_tex } }
    object { F_Block1_8 translate <40, 36, 20> texture { Red_tex } }
    object { Thing1_2 rotate -90*y translate <32, 36, 16> texture { Black_tex } }
    object { Thing2_2 translate <24, 39, 16> texture { Black_tex } }
    object { Slope1_3 translate <96, 39, 20> texture { Black_tex } }
    object { FFBlock1_1 translate <112, 48, 20> texture { T_Red_tex } }
    object { H_Block1_1 translate <24, 39, 8> texture { Black_tex } }
    object { H_Block1_1 translate <24, 39, 32> texture { Black_tex } }
    object { Thing1_4 rotate -90*y translate <24, 48, 8> texture { Black_tex } }
    object { Window_shield translate <18, 49.5, 8> texture { T_Cyan_tex } }
    object { Slope2_2 rotate 180*y translate <40, 42, 24> texture { Black_tex } }
    object { FFBlock1_1 translate <24, 51, 8> texture { T_Red_tex } }
    object { FFBlock1_1 translate <24, 51, 32> texture { T_Green_tex } }
    object { F_Block1_2 rotate -90*y translate <24, 42, 16> texture { Black_tex } }
    object { F_Block1_2 rotate -90*y translate <24, 45, 16> texture { Black_tex } }
    object { F_Triangle2_2 translate <24, 33, 8> texture { Yellow_tex } }
    object { F_Triangle2_2 rotate -90*y translate <32, 33, 24> texture { Yellow_tex } }
    object { S_Propellor2_2 translate <104, 36, 20> texture { Red_tex } }

// If you want to use this little helicopter inside an animation, and you want its rotors
// to move, then first rotate the following object around its z-axis and then move it to
// its position on the propellor base! ( Which is <x+4, y+1, z+14> )
    object { S_Propellor rotate -5*z translate <108, 37, 34> texture { Black_tex } }
    object { L_Propellor2_2 translate <24, 51, 16> texture { Black_tex } }

// Rotate the main rotor object group before placing at its base at <x+4, y, z+4>
    object { Rotor rotate 20*y translate <28, 51, 20> }
    object { Swiveltop1_2 translate <0, 13, 16> texture { Black_tex } }

// Glue to the swivel base that what is needed and then rotate and move it to <x, y-5, z>
    union {
      object { Swivelbase1_2 texture { Black_tex } }
      object { FRBlock1_1 translate <0, -9, 0> texture { T_Yellow_tex } }
      object { FRBlock1_1 translate <0, -9, 8> texture { T_Yellow_tex } }
      rotate -45*z translate <0, 8, 16>
    }
  }
  bounded_by { box { <-45, -1, -5 > <117, 63, 45> } } // Note that this bounding doesn't allow for
                                                      // rotating the main rotor, it's not wide
                                                      // enough on the z-axis !
}

object { Heli rotate -20*y translate <-20, 1, 20> }
object { Base_plate_1 translate <-120, 0, -30> }
